import Vue from 'vue'
import router from '@/router/index.js'
// 导入组件
import AddFileByTemplateDialog from './Dialog.vue'
// 使用基础 Vue 构造器，创建一个“子类”
const AddFileConstructor = Vue.extend(AddFileByTemplateDialog)

let addFileByTemplateInstance = null
/**
 * 初始化新建文件实例
 * @param {string} extendName office 文件扩展名
 * @param {string} isShowTemplateRatio 是否要展示模板选项按钮  我的创作需要展示，模板管理处不需要展示
 * @param {string} filePath 新建文件夹的父路径
 */
const initInstanceAddFileByTemplate = (
	extendName,
	isShowTemplateRatio,//默认不展示
	filePath = router.currentRoute.query.filePath || '/'
) => {
	addFileByTemplateInstance = new AddFileConstructor({
		el: document.createElement('div'),
		data() {
			return {
				extendName,
				isShowTemplateRatio,
				filePath
			}
		}
	})
}
/**
 * 新建文件 Promise 函数
 * @returns {Promise} 抛出确认和取消回调函数
 */
const showAddFileByTemplateDialog = (obj) => {
	// 非首次调用服务时，在 DOM 中移除上个实例
	if (addFileByTemplateInstance !== null) {
		document.body.removeChild(addFileByTemplateInstance.$el)
	}
	let { extendName, isShowTemplateRatio,filePath } = obj
	return new Promise((reslove) => {
		initInstanceAddFileByTemplate(extendName,isShowTemplateRatio, filePath)
		addFileByTemplateInstance.callback = (res) => {
			reslove(res)
			// 服务取消时卸载 DOM
			if (res === 'cancel' && addFileByTemplateInstance !== null) {
				document.body.removeChild(addFileByTemplateInstance.$el)
				addFileByTemplateInstance = null
			}
		}
		document.body.appendChild(addFileByTemplateInstance.$el) //  挂载 DOM
		Vue.nextTick(() => {
			addFileByTemplateInstance.visible = true //  打开对话框
		})
	})
}

export default showAddFileByTemplateDialog
